/*
  
  Hallo und Willkommen beim Doorbot. Der Code ist nicht perfekt,
  ich bin leider noch kein erfahrener Programmierer. Falls du Fehler findest
  oder eine bessere Lösung hast, kannst du mir auf "lfsystems.ch" einen Vorschlag machen.
  Auch wenn du fragen hast, kannst du dich gerne melden.
  Viel Spass
  
*/

#ifdef ESP32
#include <WiFi.h>
#else
#include <ESP8266WiFi.h>
#endif
#include <WiFiClientSecure.h>
#include <UniversalTelegramBot.h>
#include <ArduinoJson.h>
#include <iostream>
#include <string>
#include <freertos/FreeRTOS.h>
#include <freertos/task.h>
#include <EEPROM.h>
#include <AsyncTelegram2.h>

TaskHandle_t messageCheckTask;
TaskHandle_t buttonCheckTask;

// Wlan:
const char* ssid = "SSID vom Wlan";
const char* password = "Passwort";

#define BOTtoken "Bot Token"  // Vom Botfather holen

String optionenpasswort = String("Passwort");     // Passwort für Optionen

// mit "myidbot" die Telegram ID suchen

String CHAT_ID_1 = "Insert Telegram ID here";     //(Name)
String CHAT_ID_2 = "Insert Telegram ID here";     //(Name)
String CHAT_ID_3 = "Insert Telegram ID here";     //(Name)
String CHAT_ID_4 = "Insert Telegram ID here";     //(Name)
String CHAT_ID_5 = "Insert Telegram ID here";     //(Name)
String CHAT_ID_6 = "Insert Telegram ID here";     //(Name)
String CHAT_ID_7 = "Insert Telegram ID here";     //(Name)
String CHAT_ID_8 = "Insert Telegram ID here";     //(Name)
String CHAT_ID_9 = "0";                           //zusätzliche Nummer (Temporär)
String CHAT_ID_10 = "0";                          //zusätzliche Nummer (Temporär)
String CHAT_ID_11 = "Insert Telegram ID here";    //(Name)
String CHAT_ID_12 = "Insert Telegram ID here";    //(Name)

String chat_id_1 = (CHAT_ID_1);
String chat_id_2 = (CHAT_ID_2);
String chat_id_3 = (CHAT_ID_3);
String chat_id_4 = (CHAT_ID_4);
String chat_id_5 = (CHAT_ID_5);
String chat_id_6 = (CHAT_ID_6);
String chat_id_7 = (CHAT_ID_7);
String chat_id_8 = (CHAT_ID_8);
String chat_id_9 = (CHAT_ID_9);
String chat_id_10 = (CHAT_ID_10);
String chat_id_11 = (CHAT_ID_11);
String chat_id_12 = (CHAT_ID_12);

int SendeVariable;
int checkvariable;

int buttonState = 0;

#ifdef ESP8266
  X509List cert(TELEGRAM_CERTIFICATE_ROOT);
#endif

WiFiClientSecure client;
UniversalTelegramBot bot(BOTtoken, client);

int botRequestDelay = 1000;
unsigned long lastTimeBotRan;

int wifispeicher = 0; // Wifi Speicher für LED
int storedNumber = 0; // Variable zum Speichern der empfangenen Nummer
int counter = 0; // Zähler für debug
int neuenummerkontrolle = 0;   //variable um nach dem Text "Neue Nummer" eine neue nummer gespeichert werden kann
int optionenkontrolle = 0;    //Variable um Passwort abzufragen


//Outputs:
const int offnerPin = 25;
const int klingelPin = 27;
const int ledPinWlan = 22;
bool relaisState = LOW;


//Neue Nachricht
  void handleNewMessages(int numNewMessages) {
    Serial.println("handleNewMessages");
    Serial.println(String(numNewMessages));

    for (int i=0; i<numNewMessages; i++) {
      // Chat id of the requester
      String chat_id = String(bot.messages[i].chat_id);
      if (chat_id != CHAT_ID_1 && chat_id != CHAT_ID_2 && chat_id != CHAT_ID_3 && chat_id != CHAT_ID_4 && chat_id != CHAT_ID_5 && chat_id != CHAT_ID_6
       && chat_id != CHAT_ID_7 && chat_id != CHAT_ID_8 && chat_id != CHAT_ID_9 && chat_id != CHAT_ID_10 && chat_id != CHAT_ID_11 && chat_id != CHAT_ID_12) {
        bot.sendMessage(chat_id, "Unauthorized user", "");
      } else {
  
    // Print the received message
    String text = bot.messages[i].text;
    Serial.println(text);

    String from_name = bot.messages[i].from_name;

    if (text == "/start") {

      String keyboardJson = "[[\"Öffnen\"],[\"Status\",\"Neue Nummer\"],[\"Optionen\",\"Löschen\"]]";
      bot.sendMessageWithReplyKeyboard(chat_id, "Keyboard bereit", "", keyboardJson, true);

      String welcome = "Salü, " + from_name + ".\n";
      welcome += "Willkomme bim DoorBot 2.0.\n\n";
      welcome += "<Öffnen> um die Türe zu öffnen.\n";
      welcome += "<Status> um gespeicherte Nummern zu sehen.\n";
      welcome += "<Neue Nummer> um Telegram-ID zu speichern.\n";
      welcome += "<Löschen> um die Nummern zu löschen.\n";
      welcome += "<Optionen> für Einstellungen.\n";
      bot.sendMessage(chat_id, welcome, "");
    }

    if (text == "Öffnen") {
      bot.sendMessage(chat_id, "Türe geöffnet", "");
      relaisState = HIGH;
      digitalWrite(klingelPin, relaisState);
      Serial.println("Mic gedrückt");
      delay(300);
      relaisState = LOW;
      digitalWrite(klingelPin, relaisState);
      relaisState = HIGH;
      digitalWrite(offnerPin, relaisState);
      Serial.println("Öffner gedrückt");
      delay(3000);
      //bot.sendMessage(chat_id, "Door is CLOSED", "");
      relaisState = LOW;
      digitalWrite(offnerPin, relaisState);
      digitalWrite(klingelPin, relaisState);
    }

    if (text == "Neue Nummer") {
      bot.sendMessage(chat_id, "Wie lautet die neue Nummer ?", "");
      neuenummerkontrolle = 1;      // Variable zum neue nummern einspeichern
      }

    if (text == "Optionen") {
      bot.sendMessage(chat_id, "Bitte gib dein Passwort ein für weitere Optionen:", "");
      optionenkontrolle = 1;      // Variable zum neue nummern einspeichern
      }
    
    
    if (text == "Löschen") {
      CHAT_ID_9 = "0";

      uint8_t length = CHAT_ID_9.length();
      EEPROM.write(0, length);

      for (int i = 0; i < length; i++) {
        EEPROM.write(1 + i, CHAT_ID_9[i]);
      }
      EEPROM.commit();
      Serial.println("State saved in flash memory:");

      CHAT_ID_10 = "0";

      uint8_t length2 = CHAT_ID_10.length();
      EEPROM.write(20, length2);

      for (int i = 0; i < length2; i++) {
        EEPROM.write(21 + i, CHAT_ID_10[i]);
      }

      EEPROM.commit();
      Serial.println("State saved in flash memory:");

      bot.sendMessage(chat_id, "Nummern gelöscht", "");
    }


  if (optionenkontrolle == 1 && (isdigit(text.charAt(0)))) {
    if (text == optionenpasswort) {
      bot.sendMessage(chat_id, "Hier alle Optionen: (under construction)", "");
      optionenkontrolle = 0;
    } else {
      bot.sendMessage(chat_id, "Falsches Passwort.", "");
      optionenkontrolle = 0;
    }
  }


  if (neuenummerkontrolle == 1 && (isdigit(text.charAt(0)))) {

    neuenummerkontrolle = 0;

    String numberString = text.substring(0);
    Serial.println("Received String:");
    Serial.println(numberString);
    
    uint64_t receivedNumber = strtoull(numberString.c_str(), NULL, 10);
    Serial.println("Received Number:");
    Serial.println(receivedNumber);

    if (CHAT_ID_9 == "0") {
      CHAT_ID_9 = String(receivedNumber);

      uint8_t length = CHAT_ID_9.length();
      EEPROM.write(0, length);

      for (int i = 0; i < length; i++) {
        EEPROM.write(1 + i, CHAT_ID_9[i]);
      }
      EEPROM.commit();
      Serial.println("State saved in flash memory:");

      Serial.println(CHAT_ID_9);
      bot.sendMessage(chat_id, "Nummer " + numberString + " wurde in CHAT_ID_9 gespeichert.");
    } else if (CHAT_ID_10 == "0") {
      CHAT_ID_10 = String(receivedNumber);

      uint8_t length2 = CHAT_ID_10.length();
      EEPROM.write(20, length2);

      for (int i = 0; i < length2; i++) {
        EEPROM.write(21 + i, CHAT_ID_10[i]);
      }

      EEPROM.commit();
      Serial.println("State saved in flash memory:");



      Serial.println(CHAT_ID_10);
      bot.sendMessage(chat_id, "Nummer " + numberString + " wurde in CHAT_ID_10 gespeichert.");
    } else {
      bot.sendMessage(chat_id, "Kein Speicherplatz für weitere Nummern verfügbar.");
    }
  }

    
    if (text == "Status") {

      bot.sendMessage(chat_id, String(CHAT_ID_9) + " wurde in CHAT_ID_9 gespeichert.");
      bot.sendMessage(chat_id, String(CHAT_ID_10) + " wurde in CHAT_ID_10 gespeichert.");
        }
      }
    }

      vTaskDelay(pdMS_TO_TICKS(700));  // Verzögerung für die Überprüfung der Nachrichten alle 0.7 Sekunde

}

void setup() {
  Serial.begin(115200);

  EEPROM.begin(512);

  checkvariable = 1;

  pinMode(ledPinWlan, OUTPUT);
  pinMode(offnerPin, OUTPUT);
  pinMode(klingelPin, OUTPUT);
  pinMode(ledPinWlan, OUTPUT);
  digitalWrite(offnerPin, relaisState);
  
  // Connect to Wi-Fi
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  #ifdef ESP32
    client.setCACert(TELEGRAM_CERTIFICATE_ROOT);
  #endif
  while (WiFi.status() != WL_CONNECTED) {
    delay(1000);
    Serial.println("Connecting to WiFi..");
  }
  // Print ESP32 Local IP Address
  Serial.println(WiFi.localIP());
  wifispeicher = (WiFi.localIP());

  // Abrufen des ersten Strings

    uint8_t storedLength1 = EEPROM.read(0);

    char retrievedCHAT_ID_9[storedLength1 + 1];
    for (int i = 0; i < storedLength1; i++) {
      retrievedCHAT_ID_9[i] = EEPROM.read(1 + i);
    }
    retrievedCHAT_ID_9[storedLength1] = '\0';  // Null-terminieren
    Serial.println("Chat ID 9:");
    Serial.println(retrievedCHAT_ID_9);

  if (retrievedCHAT_ID_9 != "0") {
    CHAT_ID_9 = (retrievedCHAT_ID_9);
  }


  // Abrufen des zweiten Strings

    uint8_t storedLength2 = EEPROM.read(20);

    char retrievedCHAT_ID_10[storedLength2 + 1];
    for (int i = 0; i < storedLength2; i++) {
      retrievedCHAT_ID_10[i] = EEPROM.read(21 + i);
    }
    retrievedCHAT_ID_10[storedLength2] = '\0';  // Null-terminieren
    Serial.println("Chat ID 10:");
    Serial.println(retrievedCHAT_ID_10);

  if (retrievedCHAT_ID_10 != "0") {
    CHAT_ID_10 = (retrievedCHAT_ID_10);
  }

}

void loop() {

    Serial.println("before check");


      WiFi.mode(WIFI_STA);
      WiFi.begin(ssid, password);

      Serial.println("Connecting Telegram");
      #ifdef ESP32
        client.setCACert(TELEGRAM_CERTIFICATE_ROOT);
        Serial.println("Zertifikat:  ");
        Serial.print(TELEGRAM_CERTIFICATE_ROOT);
      #endif
        delay(1000);
        Serial.println("Connected to Telegram");

          Serial.println(WiFi.localIP());
          wifispeicher = (WiFi.localIP());

    int numNewMessages = bot.getUpdates(bot.last_message_received + 1);
    Serial.println("after check");

    while(numNewMessages) {
      Serial.println("got response");
      Serial.println(numNewMessages);
      handleNewMessages(numNewMessages);
      Serial.println("before getUpdates");
      numNewMessages = bot.getUpdates(bot.last_message_received + 1);

      yield();
    }
    lastTimeBotRan = millis();

    Serial.println("check");
    Serial.println(counter);
    Serial.println(bot.last_message_received);
    counter = (counter + 1);

  if (WiFi.status() == WL_CONNECTED) {
    digitalWrite(ledPinWlan, HIGH);
  } else {
    digitalWrite(ledPinWlan, LOW);

  }
}
